var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME } from './package-name';
import { FirebasePushNotificationContains } from './contains';
/**
 * Gets push notification from deep
 *
 * @throws {Error} If title is not found
 * @throws {Error} If body is not found
 *
 * @example
```ts
const pushNotification = await getPushNotification({
  deep,
  pushNotificationLinkId,
})
```
 */
export function getPushNotification(_a) {
    var _b, _c;
    var deep = _a.deep, pushNotificationLinkId = _a.pushNotificationLinkId;
    return __awaiter(this, void 0, void 0, function () {
        var titleTypeLinkId, bodyTypeLinkId, imageUrlTypeLinkId, iconUrlTypeLinkId, pushNotificationTreeLinkId, linksDownToParentPushNotificationMp, linkWithTitle, linkWithBody, linkWithImageUrl, linkWithIconUrl;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0: return [4 /*yield*/, deep.id(FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, FirebasePushNotificationContains[FirebasePushNotificationContains.PushNotificationTitle])];
                case 1:
                    titleTypeLinkId = _d.sent();
                    return [4 /*yield*/, deep.id(FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, FirebasePushNotificationContains[FirebasePushNotificationContains.PushNotificationBody])];
                case 2:
                    bodyTypeLinkId = _d.sent();
                    return [4 /*yield*/, deep.id(FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, FirebasePushNotificationContains[FirebasePushNotificationContains.PushNotificationImageUrl])];
                case 3:
                    imageUrlTypeLinkId = _d.sent();
                    return [4 /*yield*/, deep.id(FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, FirebasePushNotificationContains[FirebasePushNotificationContains.PushNotificationIconUrl])];
                case 4:
                    iconUrlTypeLinkId = _d.sent();
                    return [4 /*yield*/, deep.id(FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, FirebasePushNotificationContains[FirebasePushNotificationContains.PushNotificationTree])];
                case 5:
                    pushNotificationTreeLinkId = _d.sent();
                    return [4 /*yield*/, deep.select({
                            up: {
                                parent_id: { _eq: pushNotificationLinkId },
                                tree_id: { _eq: pushNotificationTreeLinkId },
                            },
                        }, {
                            returning: "".concat(deep.selectReturning, "\n    to {\n      ").concat(deep.selectReturning, "\n    }\n    "),
                        })];
                case 6:
                    linksDownToParentPushNotificationMp = (_d.sent()).data;
                    linkWithTitle = linksDownToParentPushNotificationMp.find(function (link) { return link.type_id === titleTypeLinkId; });
                    if (!linkWithTitle) {
                        throw new Error("A link with type ##".concat(titleTypeLinkId, " is not found"));
                    }
                    linkWithBody = linksDownToParentPushNotificationMp.find(function (link) { return link.type_id === bodyTypeLinkId; });
                    if (!linkWithBody) {
                        throw new Error("A link with type ##".concat(bodyTypeLinkId, " is not found"));
                    }
                    linkWithImageUrl = linksDownToParentPushNotificationMp.find(function (link) { return link.type_id === imageUrlTypeLinkId; });
                    linkWithIconUrl = linksDownToParentPushNotificationMp.find(function (link) { return link.type_id === iconUrlTypeLinkId; });
                    return [2 /*return*/, {
                            title: linkWithTitle === null || linkWithTitle === void 0 ? void 0 : linkWithTitle.to.value.value,
                            body: linkWithBody.to.value.value,
                            image: (_b = linkWithImageUrl === null || linkWithImageUrl === void 0 ? void 0 : linkWithImageUrl.to.value) === null || _b === void 0 ? void 0 : _b.value,
                            icon: (_c = linkWithIconUrl === null || linkWithIconUrl === void 0 ? void 0 : linkWithIconUrl.to.value) === null || _c === void 0 ? void 0 : _c.value,
                        }];
            }
        });
    });
}
