import { DeepClient } from "@deep-foundation/deeplinks/imports/client";
import { PushNotification } from './push-notification';
/**
 * Inserts push notification
 *
 * @example
```ts
const { pushNotificationLinkId } = await insertPushNotification({
  deep,
  pushNotification,
})
```
 */
export declare function insertPushNotification(param: InsertPushNotificationParam): Promise<InsertPushNotificationResult>;
export interface InsertPushNotificationParam {
    /**
     * Deep Client
     */
    deep: DeepClient;
    /**
     * Push notification
     */
    pushNotification: PushNotification;
    /**
     * Id of a link where links will be contained
     */
    containerLinkId?: number | undefined;
}
export interface InsertPushNotificationResult {
    /**
     * Push notification link id
     */
    pushNotificationLinkId: number;
}
