var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME } from "./package-name";
import { FirebasePushNotificationContains } from './contains';
/**
 * Inserts push notification
 *
 * @example
```ts
const { pushNotificationLinkId } = await insertPushNotification({
  deep,
  pushNotification,
})
```
 */
export function insertPushNotification(param) {
    return __awaiter(this, void 0, void 0, function () {
        var deep, pushNotification, _a, containerLinkId, pushNotificationTypeLinkId, titleTypeLinkId, bodyTypeLinkId, imageUrlTypeLinkId, syncTextFileTypeLinkId, containTypeLinkId, pushNotificationLinkId;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    deep = param.deep, pushNotification = param.pushNotification, _a = param.containerLinkId, containerLinkId = _a === void 0 ? deep.linkId : _a;
                    return [4 /*yield*/, deep.id(FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, FirebasePushNotificationContains[FirebasePushNotificationContains.PushNotification])];
                case 1:
                    pushNotificationTypeLinkId = _b.sent();
                    return [4 /*yield*/, deep.id(FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, FirebasePushNotificationContains[FirebasePushNotificationContains.PushNotificationTitle])];
                case 2:
                    titleTypeLinkId = _b.sent();
                    return [4 /*yield*/, deep.id(FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, FirebasePushNotificationContains[FirebasePushNotificationContains.PushNotificationBody])];
                case 3:
                    bodyTypeLinkId = _b.sent();
                    return [4 /*yield*/, deep.id(FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, FirebasePushNotificationContains[FirebasePushNotificationContains.PushNotificationImageUrl])];
                case 4:
                    imageUrlTypeLinkId = _b.sent();
                    return [4 /*yield*/, deep.id('@deep-foundation/core', 'SyncTextFile')];
                case 5:
                    syncTextFileTypeLinkId = _b.sent();
                    return [4 /*yield*/, deep.id('@deep-foundation/core', 'Contain')];
                case 6:
                    containTypeLinkId = _b.sent();
                    return [4 /*yield*/, deep.insert({
                            type_id: pushNotificationTypeLinkId,
                            in: {
                                data: [
                                    {
                                        type_id: containTypeLinkId,
                                        from_id: containerLinkId,
                                    },
                                ],
                            },
                            out: {
                                data: __spreadArray([
                                    {
                                        type_id: titleTypeLinkId,
                                        to: {
                                            data: {
                                                type_id: syncTextFileTypeLinkId,
                                                in: {
                                                    data: [
                                                        {
                                                            type_id: containTypeLinkId,
                                                            from_id: containerLinkId,
                                                        },
                                                    ],
                                                },
                                                string: {
                                                    data: {
                                                        value: pushNotification.title,
                                                    },
                                                },
                                            },
                                        },
                                        in: {
                                            data: [
                                                {
                                                    type_id: containTypeLinkId,
                                                    from_id: containerLinkId,
                                                },
                                            ],
                                        },
                                    },
                                    {
                                        type_id: bodyTypeLinkId,
                                        to: {
                                            data: {
                                                type_id: syncTextFileTypeLinkId,
                                                in: {
                                                    data: [
                                                        {
                                                            type_id: containTypeLinkId,
                                                            from_id: containerLinkId,
                                                        },
                                                    ],
                                                },
                                                string: {
                                                    data: {
                                                        value: pushNotification.body,
                                                    },
                                                },
                                            },
                                        },
                                        in: {
                                            data: [
                                                {
                                                    type_id: containTypeLinkId,
                                                    from_id: containerLinkId,
                                                },
                                            ],
                                        },
                                    }
                                ], (pushNotification.image ? [{
                                        type_id: imageUrlTypeLinkId,
                                        to: {
                                            data: {
                                                type_id: syncTextFileTypeLinkId,
                                                in: {
                                                    data: [
                                                        {
                                                            type_id: containTypeLinkId,
                                                            from_id: containerLinkId,
                                                        },
                                                    ],
                                                },
                                                string: {
                                                    data: {
                                                        value: pushNotification.body,
                                                    },
                                                },
                                            },
                                        },
                                        in: {
                                            data: [
                                                {
                                                    type_id: containTypeLinkId,
                                                    from_id: containerLinkId,
                                                },
                                            ],
                                        },
                                    }] : []), true),
                            },
                        })];
                case 7:
                    pushNotificationLinkId = (_b.sent()).data[0].id;
                    return [2 /*return*/, { pushNotificationLinkId: pushNotificationLinkId }];
            }
        });
    });
}
