var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME } from './package-name';
import { FirebasePushNotificationContains } from './contains';
/**
 * Inserts service account
 *
 * @example
```ts
const { serviceAccountLinkId } = await insertServiceAccount({
  deep,
  serviceAccount,
  shouldMakeActive,
})
```
 */
export function insertServiceAccount(param) {
    return __awaiter(this, void 0, void 0, function () {
        var deep, serviceAccount, _a, shouldMakeActive, containTypeLinkId, serviceAccountTypeLinkId, usesServiceAccountTypeLinkId, _b, _c, serviceAccountLinkId;
        var _d, _e, _f;
        return __generator(this, function (_g) {
            switch (_g.label) {
                case 0:
                    deep = param.deep, serviceAccount = param.serviceAccount, _a = param.shouldMakeActive, shouldMakeActive = _a === void 0 ? false : _a;
                    return [4 /*yield*/, deep.id('@deep-foundation/core', 'Contain')];
                case 1:
                    containTypeLinkId = _g.sent();
                    return [4 /*yield*/, deep.id(FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, FirebasePushNotificationContains[FirebasePushNotificationContains.ServiceAccount])];
                case 2:
                    serviceAccountTypeLinkId = _g.sent();
                    return [4 /*yield*/, deep.id(FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, FirebasePushNotificationContains[FirebasePushNotificationContains.UsesServiceAccount])];
                case 3:
                    usesServiceAccountTypeLinkId = _g.sent();
                    if (!shouldMakeActive) return [3 /*break*/, 6];
                    _c = (_b = deep).delete;
                    _d = {};
                    _e = {};
                    _f = {};
                    return [4 /*yield*/, deep.id('@deep-foundation/core', 'containTree')];
                case 4: return [4 /*yield*/, _c.apply(_b, [(_d.up = (_e.tree_id = (_f._eq = _g.sent(), _f),
                            _e.parent = {
                                type_id: { _id: ['@deep-foundation/core', 'Contain'] },
                                to: { type_id: usesServiceAccountTypeLinkId },
                                from_id: deep.linkId,
                            },
                            _e),
                            _d)])];
                case 5:
                    _g.sent();
                    _g.label = 6;
                case 6: return [4 /*yield*/, deep.insert({
                        type_id: serviceAccountTypeLinkId,
                        object: {
                            data: {
                                value: serviceAccount,
                            },
                        },
                        in: {
                            data: __spreadArray([
                                {
                                    type_id: containTypeLinkId,
                                    from_id: deep.linkId,
                                }
                            ], (shouldMakeActive
                                ? [
                                    {
                                        type_id: usesServiceAccountTypeLinkId,
                                        from_id: deep.linkId,
                                        in: {
                                            data: [
                                                {
                                                    type_id: containTypeLinkId,
                                                    from_id: deep.linkId,
                                                },
                                            ],
                                        },
                                    },
                                ]
                                : []), true),
                        },
                    })];
                case 7:
                    serviceAccountLinkId = (_g.sent()).data[0].id;
                    return [2 /*return*/, { serviceAccountLinkId: serviceAccountLinkId }];
            }
        });
    });
}
