var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Device } from '@capacitor/device';
import { PushNotifications } from '@capacitor/push-notifications';
import { getToken, onMessage } from '@firebase/messaging';
import { insertDeviceRegistrationToken } from './insert-device-registration-token';
import { FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME } from './package-name';
import { FirebasePushNotificationContains } from './contains';
/**
 * Registers device
 *
 * @example
```ts
await registerDevice({
  deep,
  deviceLinkId,
  firebaseMessaging,
})
```
 */
export function registerDevice(_a) {
    var deep = _a.deep, deviceLinkId = _a.deviceLinkId, firebaseMessaging = _a.firebaseMessaging, callback = _a.callback;
    return __awaiter(this, void 0, void 0, function () {
        function onDeviceRegistration(_a) {
            var deviceRegistrationToken = _a.value;
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (!callback) return [3 /*break*/, 1];
                            callback({ deviceRegistrationToken: deviceRegistrationToken });
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, insertDeviceRegistrationToken({
                                deep: deep,
                                deviceRegistrationToken: deviceRegistrationToken,
                                deviceLinkId: deviceLinkId,
                            })];
                        case 2:
                            _b.sent();
                            _b.label = 3;
                        case 3: return [2 /*return*/];
                    }
                });
            });
        }
        var platform, serviceWorkerRegistration, webPushCertificateLink, webPushCertificate, deviceRegistrationToken;
        var _this = this;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, Device.getInfo()];
                case 1:
                    platform = (_b.sent()).platform;
                    if (!(platform === 'web')) return [3 /*break*/, 5];
                    return [4 /*yield*/, navigator.serviceWorker.register('./firebase-messaging-sw.js', { scope: 'firebase-cloud-messaging-push-scope' })];
                case 2:
                    serviceWorkerRegistration = _b.sent();
                    return [4 /*yield*/, getPushCertificateLink({ deep: deep })];
                case 3:
                    webPushCertificateLink = _b.sent();
                    webPushCertificate = webPushCertificateLink.value.value;
                    return [4 /*yield*/, getToken(firebaseMessaging, {
                            serviceWorkerRegistration: serviceWorkerRegistration,
                            vapidKey: webPushCertificate,
                        })];
                case 4:
                    deviceRegistrationToken = _b.sent();
                    onDeviceRegistration({ value: deviceRegistrationToken });
                    onMessage(firebaseMessaging, function (payload) { return __awaiter(_this, void 0, void 0, function () {
                        var permission;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    console.log('[firebase-messaging-sw.js] Received background message ', payload);
                                    if (!payload.notification) {
                                        return [2 /*return*/];
                                    }
                                    if (!payload.notification.title) {
                                        return [2 /*return*/];
                                    }
                                    if (!!('Notification' in window)) return [3 /*break*/, 1];
                                    throw new Error('This browser does not support desktop notification');
                                case 1:
                                    if (!(Notification.permission === 'granted')) return [3 /*break*/, 2];
                                    // If it's okay, let's create a notification
                                    new Notification(payload.notification.title, payload.notification);
                                    return [3 /*break*/, 4];
                                case 2:
                                    if (!(Notification.permission !== 'denied')) return [3 /*break*/, 4];
                                    return [4 /*yield*/, Notification.requestPermission()];
                                case 3:
                                    permission = _a.sent();
                                    if (permission === 'granted') {
                                        new Notification(payload.notification.title, payload.notification);
                                    }
                                    _a.label = 4;
                                case 4: return [2 /*return*/];
                            }
                        });
                    }); });
                    return [3 /*break*/, 9];
                case 5: return [4 /*yield*/, PushNotifications.removeAllListeners()];
                case 6:
                    _b.sent();
                    return [4 /*yield*/, PushNotifications.addListener('registration', onDeviceRegistration)];
                case 7:
                    _b.sent();
                    return [4 /*yield*/, PushNotifications.register()];
                case 8:
                    _b.sent();
                    _b.label = 9;
                case 9: return [2 /*return*/];
            }
        });
    });
}
function getPushCertificateLink(_a) {
    var _b;
    var deep = _a.deep;
    return __awaiter(this, void 0, void 0, function () {
        var webPushCertificateTypeLinkId, usesWebPushCertificateTypeLinkId, containTypeLinkId, selectData, data, webPushCertificateLink, usesWebPushCertificateLinks, usesWebPushCertificateLink_1, webPushCertificateLinks;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, deep.id(FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, FirebasePushNotificationContains[FirebasePushNotificationContains.WebPushCertificate])];
                case 1:
                    webPushCertificateTypeLinkId = _c.sent();
                    return [4 /*yield*/, deep.id(FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, FirebasePushNotificationContains[FirebasePushNotificationContains.UsesWebPushCertificate])];
                case 2:
                    usesWebPushCertificateTypeLinkId = _c.sent();
                    return [4 /*yield*/, deep.id('@deep-foundation/core', 'Contain')];
                case 3:
                    containTypeLinkId = _c.sent();
                    selectData = {
                        _or: [
                            {
                                type_id: webPushCertificateTypeLinkId,
                                in: {
                                    type_id: containTypeLinkId,
                                    from_id: deep.linkId,
                                },
                            },
                            {
                                type_id: usesWebPushCertificateTypeLinkId,
                                from_id: deep.linkId,
                            },
                        ],
                    };
                    return [4 /*yield*/, deep.select(selectData)];
                case 4:
                    data = (_c.sent()).data;
                    if (data.length === 0) {
                        throw new Error("Select with data ".concat(JSON.stringify(selectData), " returned empty result"));
                    }
                    usesWebPushCertificateLinks = data.filter(function (link) { return link.type_id === usesWebPushCertificateTypeLinkId; });
                    if (usesWebPushCertificateLinks.length > 1) {
                        throw new Error("Select with data ".concat(JSON.stringify(selectData), " returned more than one link of type ##").concat(usesWebPushCertificateTypeLinkId, ": ").concat(usesWebPushCertificateLinks
                            .map(function (link) { return "##".concat(link.id); })
                            .join(',')));
                    }
                    else if (usesWebPushCertificateLinks.length === 1) {
                        usesWebPushCertificateLink_1 = usesWebPushCertificateLinks[0];
                        webPushCertificateLink = data.find(function (link) { return link.id === usesWebPushCertificateLink_1.to_id; });
                    }
                    else {
                        webPushCertificateLinks = data.filter(function (link) { return link.type_id === webPushCertificateTypeLinkId; });
                        if (webPushCertificateLinks.length > 1) {
                            throw new Error("Select with data ".concat(JSON.stringify(selectData), " returned more than one link of type ##").concat(webPushCertificateTypeLinkId, ": ").concat(webPushCertificateLinks
                                .map(function (link) { return "##".concat(link.id); })
                                .join(',')));
                        }
                        webPushCertificateLink = webPushCertificateLinks[0];
                    }
                    if (!webPushCertificateLink) {
                        throw new Error(
                        // `A link with type ##${usesWebPushCertificateTypeLinkId}, from ##${deep.linkId} to ##${webPushCertificateTypeLinkId} is not found`
                        "".concat(JSON.stringify(selectData), " query has found 0 links"));
                    }
                    if (!((_b = webPushCertificateLink.value) === null || _b === void 0 ? void 0 : _b.value)) {
                        throw new Error("##".concat(webPushCertificateLink.id, " must have a value"));
                    }
                    return [2 /*return*/, webPushCertificateLink];
            }
        });
    });
}
